'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.render = exports.Gather = exports.Message = exports.Play = exports.Say = exports.Response = exports.pureRender = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _server = require('react-dom/server');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// convert instance rendered HTML to XML
var pureRender = exports.pureRender = function pureRender(instance) {
  return xmlize((0, _server.renderToStaticMarkup)(instance));
};

// hack #1 : upper case tag names from React output
var xmlize = function xmlize(html) {
  return '<?xml version="1.0" encoding="UTF-8"?>' + html.replace(/(<\/?[a-z])/g, function (v) {
    return v.toUpperCase();
  });
};

// hack #2 : is attribue enable non-standards attributes
// https://github.com/facebook/react/issues/140#issuecomment-114290163
var Response = exports.Response = function Response(props) {
  return _react2.default.createElement('response', _extends({ is: true }, props));
};
var Say = exports.Say = function Say(props) {
  return _react2.default.createElement('say', _extends({ is: true }, props));
};
var Play = exports.Play = function Play(props) {
  return _react2.default.createElement('play', _extends({ is: true }, props));
};
var Message = exports.Message = function Message(props) {
  return _react2.default.createElement('message', _extends({ is: true }, props));
};
var Gather = exports.Gather = function Gather(props) {
  return _react2.default.createElement('gather', _extends({ is: true }, props));
};

// resolve async stuff if any, then render the final component
// will add props.state from the eventual promise
// and a save method
var render = exports.render = function render(Component, props, req, promise) {
  // save in express cache
  var save = function save(data) {
    return req.session.state = data;
  };
  var newProps = Object.assign({}, props, { save: save });
  if (!promise) {
    return pureRender(_react2.default.createElement(Component, newProps));
  }
  return promise.then(function (promiseProps) {
    newProps = Object.assign({}, newProps, {
      state: promiseProps
    });
    return pureRender(_react2.default.createElement(Component, newProps));
  }).catch(function (e) {
    return console.log(e);
  });
};